#ifndef __W_MAIN__
#define __W_MAIN__

#include "p_mobj.h"
#include "d_player.h"


#define MAXMANA 999999 
#define GETRATE (TICRATE*2)//How fast the mana is retrived.
#define GETDISTANCE (256*FRACUNIT)
#define MANACONTENT ((P_Random()%125)+75)
#define MANAPOINT (P_Random()%3)
#define ORDERANGLE (ANGLE_1*45.0)

#define IsMonster(mo) ((mo->flags & MF_COUNTKILL) || (mo->type==MT_SKULL))

/*
typedef enum
{
	MT_POSSESSED,
	MT_BBARREL,
	MT_SHOTGUY,
	MT_CHAINGUY,
	MT_TROOP,
	MT_SERGEANT,
	MT_SHADOWS,
	MT_HEAD,
	MT_PAIN,
	MT_KNIGHT,
	MT_BRUISER,
	MT_UNDEAD,
	MT_FATSO,
	MT_BABY,
	MT_SPIDER,
	MT_VILE,
	MT_CYBORG,
	NUM_SPAWNTYPES
}
*/

typedef enum
{
	possessed,
	blockbarrel,
	seargant,
	chaingunner,
	imp,
	deamon,
	spector,
	cacodeamon,
	painelemental,
	hellknight,
	hellbaron,
	revenant,
	mancubus,
	arachnotron,
	mastermind,
	archvile,
	cyberdeamon,
	NUM_SPAWNTYPES
};


void SetMovetarget(mobj_t *, fixed_t, fixed_t);
boolean Spawn_Monster(int, player_t *, angle_t );
void MonsterExtraThink(mobj_t *);
void SetFollow(mobj_t *);
void SetGuard(mobj_t *);
void PlayerDeath(mobj_t *);
void W_MapControl(player_t *);
void W_Deselect(player_t *);


extern char *monstername[NUM_SPAWNTYPES];
extern mobjtype_t monsters[NUM_SPAWNTYPES];
extern int monsterprice[NUM_SPAWNTYPES];

extern mobj_t *looker;

extern short localmousex;
extern short localmousey;


#endif